// Avago RGBC Sensor Library
// Header

#ifndef I2C_RGBC_Reader_h
#define I2C_RGBC_Reader_h

#include <Wire.h>
//#include <WProgram.h>


class I2C_RGBC_Reader {
public:
  I2C_RGBC_Reader(); // constructor
  // as per http://www.arduino.cc/cgi-bin/yabb2/YaBB.pl?num=1250997678
  String WhoAmI();
  void begin();

  void standard();    // default values
  void calibrate();   // gain and capacitors
  void white();     // white balance
  void offset();     // offset
  void parameters();  // print parameters

  void get();
  void getRGBC(int &r, int &g, int &b, int &c);
  void memorise(int colourNumber);
  void recognise(int &colourNumber, int &proximity);

private:
  int _address;
  int _none;
  int _r[8];
  int _g[8];
  int _b[8];
  int _c[8];
  float _referenceDistance;
  int _red, _green, _blue, _clear;
  float _redFactor;
  float _blueFactor;
  float _greenFactor;
  int _calibrateClearGain(); 
  int _calibrateColorGain();
  void _calibrateCapacitors();
};

#endif